<?php  

    /**********************************************************************
    this is a sample of the code you should use on your production plugin
    this part check and validate the license key
    /**********************************************************************/
	
	// Prevent loading this file directly - Busted!
	if ( ! class_exists( 'WP' ) )
	{
		header( 'Status: 403 Forbidden' );
		header( 'HTTP/1.1 403 Forbidden' );
		exit;
	}

    // register settings
    function wprs_comparison_my_settings_init() {
        // register the settins for the plugin here   (you might want to give it more unique names)
		register_setting( 'wprs_comparison_plugin_options_group', 'wprs_comparison_options', 'wprs_comparison_sanitize_wprs_comparison_validate_options' );
    }
    add_action('admin_init', 'wprs_comparison_my_settings_init');
	add_action('init','wprs_comparison_check_active');

    // register the plugin admin page
    // this is called if the plugin is valid and ok
    function wprs_comparison_my_add_plugin_admin_page(){
		
		add_submenu_page('wprs',
							'<i class="fa fa-cube"></i> '.__('Compare', 'wprs'), 
							'<i class="fa fa-cube"></i> '.__('Compare', 'wprs'), 
							'manage_options',
							'wprs-comparison',
							'wprs_comparison_my_plugin_admin_page'
						);
    }


	// Sanitize and validate input. Accepts an array, return a sanitized array.
	function wprs_comparison_sanitize_wprs_comparison_validate_options($input) {
		// do stuff with $options to check they are ok
        if(isset($_POST['reset'])){
			delete_option('wprs_comparison_settings_license_option');
		}	
		return $input;
	}

			
	
    /**
    * call back function that renders your plugins settings page
    * 
    */
    function wprs_comparison_my_plugin_admin_page(){
		
		$options = get_option('wprs_comparison_options');
		
        echo '<div class="wrap">';
		wprs_comparison_screen_icon();
		echo '<h2>'.WPRSComparison_PLUGIN_NAME.' Settings <span style="font-size:10px;">Ver '.WPRSComparison_VER.'</span></h2>';
		echo '<form method="post" action="options.php">';
		settings_fields('wprs_comparison_plugin_options_group');
		settings_errors();
		require_once ('settings_compare.php');		// load table settings
		echo '<div style="clear:both;"></div>';
		echo '</div>';
		echo '<div style="clear:both;"></div>';
        echo '</form>';
    }
	
    // this function should definitely be obfuscated or encrypted so hacker cannot bypass it
    // we call this function at the init action so it can set up all the proper actions and filters that the plugin would use.
    // we only do the actions required for validation if the plugin is not yet valid
    function wprs_comparison_check_active(){      

            // plugin is ok
            // do the actions and filters
			add_action( 'admin_menu',	'wprs_comparison_my_add_plugin_admin_page', 99); // the function to show the plugin settings page
    }

	
// ------------------------------------------------------------------------------
// CALLBACK FUNCTION FOR: register_activation_hook(__FILE__, 'wprs_comparison_add_defaults')
// ------------------------------------------------------------------------------
// THIS FUNCTION RUNS WHEN THE PLUGIN IS ACTIVATED. IF THERE ARE NO THEME OPTIONS
// CURRENTLY SET, OR THE USER HAS SELECTED THE CHECKBOX TO RESET OPTIONS TO THEIR
// DEFAULTS THEN THE OPTIONS ARE SET/RESET.
//
// OTHERWISE, THE PLUGIN OPTIONS REMAIN UNCHANGED.
// ------------------------------------------------------------------------------

	// Define default option settings
	function wprs_comparison_add_defaults() {
		$tmp = get_option('wprs_comparison_options');
    	if(($tmp['wprs_comparison_chk_default_options_db']=='1')||(!is_array($tmp))) {
			delete_option('wprs_comparison_options'); // so we don't have to reset all the 'off' checkboxes too! ( I don't think this is needed but leave for now)
			$arr = array(	
							// add default setting below...
							
							// general settings
							
							// other settings
							"wprs_comparison_chk_default_options_db" => ""
			);
			update_option('wprs_comparison_options', $arr);
		}
	}


// ------------------------------------------------------------------------------
// Some requires FUNCTIONs
// ------------------------------------------------------------------------------
// Add any extra functions required by setting page below
// ------------------------------------------------------------------------------

			
	// screen icon function, can be called by wprs_comparison_screen_icon();
		function wprs_comparison_screen_icon () {
			echo '<div class="icon32 wprs_comparison_icon32" id=""></div>';
		}

	
		// set up plugin actions
    add_action( 'admin_init', 'wprs_comparison_requires_wordpress_version' );			// check WP version 3.0+

	// ------------------------------------------------------------------------
	// REQUIRE MINIMUM VERSION OF WORDPRESS:                                               
	// ------------------------------------------------------------------------
	function wprs_comparison_requires_wordpress_version() {
		global $wp_version;
		$plugin = plugin_basename( __FILE__ );
		$plugin_data = get_plugin_data( __FILE__, false );

		if ( version_compare($wp_version, "3.0", "<" ) ) {
			if( is_plugin_active($plugin) ) {
				deactivate_plugins( $plugin );
				wp_die( "'".$plugin_data['Name']."' requires WordPress 3.0 or higher, and has been deactivated! Please upgrade WordPress and try again.<br /><br />Back to <a href='".admin_url()."'>WordPress admin</a>." );
			}
		}
	}
	
	// check if WP Reviews is active
	function wprs_comparison_detect_wprs()  {
		$xplugin = 'wp-rich-snippets/wp-rich-snippets.php';
		$plugin = plugin_basename( __FILE__ );
		if ( !is_plugin_active($xplugin) ) {
			// display notice if plugin isn't active
			add_action('admin_notices', 'wprs_comparison_my_admin_notice');
			// deactivate
			deactivate_plugins( $plugin );
		}
	}
	add_action( 'admin_init', 'wprs_comparison_detect_wprs' );
	
	// the notice
	function wprs_comparison_my_admin_notice(){
		echo '<div class="update-nag"><p>The <a href="http://authorhreview.com/plugins/wp-rich-snippets/" title="WordPress Rich Snippets Plugin" target="_blank" >WP Rich Snippets</a> plugin is required. Plugin has been deactivated!</p></div>';
	}