<?php
	/*
	WPRS Comparison Table shortcode
	***************************/

// Prevent loading this file directly - Busted!
	if ( ! class_exists( 'WP' ) )
	{
		header( 'Status: 403 Forbidden' );
		header( 'HTTP/1.1 403 Forbidden' );
		exit;
	}
	
	// add shortcode
	add_action('init' , 'wprs_comparison_shortcode_init');
	// enable shortcode in widget area
	add_filter('widget_text', 'do_shortcode');
	
	function wprs_comparison_shortcode_init() {
		add_shortcode( 'wprs-compare' , 'wprs_comparison_display' );
	}

	
	
	//----------------------------------------------
	// start display shortcode
	function wprs_comparison_display($atts, $content = null) {
		//$img ='';
		extract(shortcode_atts(array(
                "ids" => '',								// post ids
				"num" => '10',								// number of posts, default = 10
				"order" => 'meta_value_num',				// order, default = meta_value_num (rating, rank)
                "cpt" => 'post',							// custom post type
				"type" => 'rating',							// editor/author
				//"cat" => '',								// categories, not used!
				"images" => '',								// enable/disable images
				"title" => __('Product', 'wprs-compare'), 	// edit table header, default = Product
				"description" => '',						// enable/disable description
				"price" => '',								// enable/disable price
				"rating" => '',								// enable/disable price
				"criteria" => '',							// enable/disable criteria
				"action" => '',								// enable/disable price
				"about" => '',								// About this table
				"markup" => '',								// enable/disable price output markup
        ), $atts));
		
		global $wp, $post, $wprs_prefix;
		// get plugin options
		$options = get_option('wprs_comparison_options');
		// get WP Reviews plugin options
		$wpr_options = get_option('wprs_options');
		
		// get currency and currency sympol
		if (isset($wpr_options['wprs_currency']) != '') {$currency = $wpr_options['wprs_currency'];} else {$currency = 'USD';}
		$currency_sympol = wprs_get_currency_symbol($currency);
		
		$wprs_comparison_rank = 1; // set rank
		
		$reviews_table = '';
		$wprs_comparison_rating = '';
		$wprs_comparison_summary = '';
		$wprs_comparison_price = '';
		$review_url = '';
		$url = '';
		
		if(!isset($ids)) return;
		$thePostIdArray = explode(',', $ids);
		
		// custom post type
		if(isset($cpt)) {$ptype = $cpt;} else {$ptype = 'post';}
		// set review type (author/user) default is: editor
		//if (isset($type)) {$reviewtype = $type;} else {$reviewtype = 'editor';}
			
		$reviewtype = $type;
		$r = array();			
		
		// query based on type
		if ($type == 'rating') {
			$icon_type = '<span class="icon-user"></span> '.__('Editor', 'wprs-compare').' ';
			$r = new WP_Query(array(	
									'post_type' => $ptype,
									'post__in' => $thePostIdArray,
									'posts_per_page' => $num,
									'no_found_rows' => true,
									'post_status' => 'publish',
									'meta_key'=> $wprs_prefix.'star_rating',
									//'category' => $cat,
									'ignore_sticky_posts' => true,
									'orderby'=> $order,
									'order'=> 'DESC',
								));
		}
		
		if ($type == 'percentage') {
			$icon_type = '<span class="icon-user"></span> '.__('Editor', 'wprs-compare').' ';
			$r = new WP_Query(array(	
									'post_type' => $ptype,
									'post__in' => $thePostIdArray,
									'posts_per_page' => $num,
									'no_found_rows' => true,
									'post_status' => 'publish',
									'meta_key'=> $wprs_prefix.'slider_percentage',
									//'category' => $cat,
									'ignore_sticky_posts' => true,
									'orderby'=> $order,
									'order'=> 'DESC',
								));
		} 
		
		if ($type == 'votes') {
			$icon_type = '<span class="icon-user"></span> '.__('User', 'wprs-compare').' ';
			$r = new WP_Query(array(	
									'post_type' => $ptype,
									'post__in' => $thePostIdArray,
									'posts_per_page' => $num,
									'no_found_rows' => true,
									'post_status' => 'publish',
									'meta_key'=> $wprs_prefix.'user_rating_all',
									//'category' => $cat,
									'ignore_sticky_posts' => true,
									'orderby'=> $order,
									'order'=> 'DESC',
								));
		} 
		
		if ($type == 'aggregate') {
			$icon_type = '<span class="icon-user"></span> '.__('User', 'wprs-compare').' ';
			$r = new WP_Query(array(	
									'post_type' => $ptype,
									'post__in' => $thePostIdArray,
									'posts_per_page' => $num,
									'no_found_rows' => true,
									'post_status' => 'publish',
									'meta_key'=> $wprs_prefix.'userrating_average',
									//'category' => $cat,
									'ignore_sticky_posts' => true,
									'orderby'=> $order,
									'order'=> 'DESC',
								));
		} 
		
		
		
		if ($r->have_posts()) :
		
		//$xray = array();
		
		/*
		echo '<pre>';
		print_r($r);
		echo '</pre>';
		
		$r = flipDiagonally($r);
		*/
		//echo '<pre>';
		//print_r($r);
		//echo '</pre>';
		
		
	
		
		$xxx = 0;
		$xray = array();
		
		while ($r->have_posts()) : $r->the_post();
	
		// get custom vaules
		$custom = get_post_custom();
		
		$wprs_template = wprs_template($post->ID);
	
		
		// create our array
		$xray['Name'][$xxx] = isset($wprs_template['item_name']) ? array($wprs_template['item_name']) : '';
		$xray['Media'][$xxx] = wprs_review_media_extend($post->ID, 320, 180) ? array(wprs_review_media_extend($post->ID, 320, 180)) : '';
		if ($type == 'rating') {
			$xray['Rating'][$xxx] = isset($wprs_template['editor_star_rating_no_markup']) ? array($wprs_template['editor_star_rating_no_markup']) : '';
		}
		
		if ($type == 'percentage') {
			$xray['Rating'][$xxx] = isset($wprs_template['progressbar_editor']) ? array($wprs_template['progressbar_editor']) : '';
		}
		if ($type == 'votes') {
			$xray['Rating'][$xxx] = isset($wprs_template['user_star_rating_raw']) ? array($wprs_template['user_star_rating_raw']) : '';
		}
		if ($type == 'aggregate') {
			$xray['Rating'][$xxx] = isset($wprs_template['user_star_aggregate_raw']) ? array($wprs_template['user_star_aggregate_raw']) : '';
		}
		$xray['Price'][$xxx] = isset($wprs_template['price_raw']) ? array($wprs_template['price_raw']) : '';
		
		$xray['Criteria'][$xxx] = isset($wprs_template['criteria_editor']) ? array($wprs_template['criteria_editor']) : '';
		if ($type == 'aggregate') {
			$xray['Criteria'][$xxx] = isset($wprs_template['criteria_user']) ? array($wprs_template['criteria_user']) : '';
		}
		$xray['Description'][$xxx] = isset($wprs_template['description']) ? array($wprs_template['description']) : '';
		//$xray['Pros'][$xxx] = isset($wprs_template['pros']) ? array($wprs_template['pros']) : '';
		//$xray['Cons'][$xxx] = isset($wprs_template['cons']) ? array($wprs_template['cons']) : '';
		$xray['Action'][$xxx] = isset($wprs_template['links_mini']) ? array($wprs_template['links_mini']) : '';
		
		
		$xxx = $xxx + 1;
		
		endwhile;
		
		endif;
		
		// reset the global $the_post as this query will have stomped on it
		wp_reset_postdata();
		
		// debug
		//echo '<pre>';
		//print_r($xray);
		//echo count($xray['Name']);
		//echo '</pre>';
		
		// check if the array is empty,
		// check if logged in user can manage option
		// then return
		if ( empty($xray) ) {
			if (current_user_can('manage_options') ) return '<p><i class="fa fa-info-circle"></i> '.__('No entries!', 'wprs-compare').'<p>';
			return '';
		}
		
		// we need to decide how many columns
		//$entries_count = count($xray['Name']) + 0;
		$entries_count = 2;
		$compare_table = '';
		
		// output schema Table markup, open div
		if ( isset($markup) && $markup == 'yes') {
			$compare_table .= '<div itemscope itemtype="http://schema.org/Table">';
			if ( isset($about) && $about != '') $compare_table .= '<meta itemprop="about" content="'.$about.'"/>';
		}
		
		//echo '<table><tr><th></th><th>Product 1</th><th>Product 2</th></tr>';
		$compare_table .= '<div class="table-responsive">';
		$compare_table .= '<table class="table table-striped table-bordered table-hover wprs_comparison criteria_small">';
		$compare_table .= '<thead>';
		$compare_table .= '<tr><th class="col-xs-'.$entries_count.' col-sm-'.$entries_count.' col-md-'.$entries_count.'"></th>';
		for($i = 0; $i < count($xray['Name']); ++$i) {
			$compare_table .= '<th class="col-xs-'.$entries_count.' col-sm-'.$entries_count.' col-md-'.$entries_count.'">';
			if ($images != 'no')  $compare_table .= $xray['Media'][$i][0] . '<br />' ;
			//if ($images == 'no') {}
			$compare_table .= $xray['Name'][$i][0];
			$compare_table .= '</th>';
		}
		echo '</tr>';
		$compare_table .= '</thead>';
		
		$compare_table .= '<tbody>';
		foreach($xray as $id => $item) {
    	//$compare_table .= '<tr><td>'.$id.'</td><td>'.$item[0][0].'</td><td>'.$item[1][0].'</td><td>'.$item[2][0].'</td></tr>';
		
		$tr_class = 'class="';
		//if ($id != 'Price') {} else {$tr_class .= ' success';}
		//if ($id != 'Action') {} else {$tr_class .= ' info';}
		$tr_class .= '"';
		
		$compare_table .= '<tr '.$tr_class.'>';
			if ($id != 'Name' && $id != 'Media') {
				if (	$id == 'Description' && $description == 'no' || 
						$id == 'Rating' && $rating == 'no' ||
						$id == 'Action' && $action == 'no' ||
						$id == 'Price' && $price == 'no'   ||
						$id == 'Criteria' && $criteria == 'no' )
					{
					// do thing!
				} else {
					if ( $id == 'Action' ) {
						// include an empty td
						$compare_table .= '<td> </td>';
					} else {
						// include the title
						//$compare_table .= '<td>'.$id.'</td>';
						// for translation
						// @since 1.1
						if ($id == 'Description') { $id_display = __('Description','wprs-compare');}
						if ($id == 'Rating') { $id_display = __('Rating','wprs-compare');}
						if ($id == 'Action') { $id_display = __('Action','wprs-compare');}
						if ($id == 'Price') { $id_display = __('Price','wprs-compare');}
						if ($id == 'Criteria') { $id_display = __('Criteria','wprs-compare');}
						$compare_table .= '<td>'.$id_display.'</td>';
					}
				}
			}
			for($i = 0; $i < count($xray['Name']); ++$i) {
				if ( $id != 'Name' && $id != 'Media' && isset($item[$i][0]) ) {
					if (	$id == 'Description' && $description == 'no' || 
							$id == 'Rating' && $rating == 'no' ||
							$id == 'Action' && $action == 'no' ||
							$id == 'Price' && $price == 'no'   ||
							$id == 'Criteria' && $criteria == 'no' )
					{
						// do nothing!
					} else {
						// include the value
						$compare_table .= '<td>'.$item[$i][0].'</td>';
					}
				}
			}
		$compare_table .= '</tr>';
		}
		$compare_table .= '</tbody>';
		$compare_table .= '</table>';
		$compare_table .= '</div>';
		
		// output schema Table markup, close div
		if ( isset($markup) && $markup == 'yes') {
			$compare_table .= '</div>';
		}
		
		return $compare_table;	
}
