<?php
	/*
	Plugin Name: WPRS Compare
    Plugin URI: https://wprichsnippets.com
    Description: This is a Comparison Table add-on for the WP Rich Snippets plugin, display a Comparison Table anywhere using a shortcode.
    Version: 1.2
    Author: Hesham Zebida
    Author URI: http://zebida.com
    Last Version update : 27 August 2016
    */
	
	
	// Prevent loading this file directly - Busted!
	if ( ! class_exists( 'WP' ) )
	{
		header( 'Status: 403 Forbidden' );
		header( 'HTTP/1.1 403 Forbidden' );
		exit;
	}
	
	// plugin version, used to add version for scripts and styles
	define( 'WPRSComparison_VER', '1.2' );
	define( 'WPRSComparison_PLUGIN_NAME', 'WPRS Compare' );
	
	
	// Localization
	add_action('init', 'wprscompare_localization_init');
	/*
		Load the WPRS Ranking Table textdomain for internationalization.
		*/
	function wprscompare_localization_init() {
	
		$path = dirname(plugin_basename( __FILE__ )) . '/inc/languages/';
		$loaded = load_plugin_textdomain('wprs-compare', false, $path);
		if(isset($_GET['page'])) {
			if ($_GET['page'] == basename(__FILE__) && !$loaded) {          
				echo '<div class="error">WPRS Compare Add-on Localization: ' . __('Could not load the localization file: ' . $path, 'wprs-compare') . '</div>';
				return;
			}
		}
	
	}
	
	// required
	require_once ('inc/admin/settings.php');								// load admin settings
	require_once ('inc/shortcode_compare.php');								// load shortcode
	
	